/*
 * Copyright (c) 2004-2005 CAS Software AG, 
 * 10 Wilhelm-Schickard Street, 76131 Karlsruhe, Germany
 * 
 * Copyright (c) 2004-2006 FZI Forschungszentrum Informatik, 
 * 10-14 Haid-und-Neu Street, 76131 Karlsruhe, Germany
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
	$Header: /cvsroot/sissy/SISSy/src/de/fzi/delphi/parser/dpr_tree.g,v 1.3 2008/04/23 18:49:34 mtrifu Exp $
*/

header{	// Package
	package de.fzi.delphi.parser;
	// Imports
    import java.util.List;
    import java.util.Vector;
    import antlr.*;
}
class DPRTree extends TreeParser;
options {
	buildAST=true;
	ASTLabelType = "CommonAST";
	importVocab=DPRParser;	
}

goal
	:	libraryClause
		usesClause
		( exportsClause )?
	;

libraryClause
	:	#( LIBRARY IDENT )
	;
		
usesClause
	:	#( USES
			( unitEntry )+
		)
	;

unitEntry

	:	#( IDENT 
			( unitInFile )?
		)
	;

unitInFile
	:
		#( IN 
			STRING_LIT
		)
	;
exportsClause
	:	#( EXPORTS
			( IDENT )+
		)
	;
	